%define anolis_release 2
%global pypi_name mmcv
%global pypi_version 1.7.0
%define debug_package %{nil}

%define have_cuda 1
%global vcu_maj 12
%global vcu_min 1 

Name:           python-%{pypi_name}
Version:        %{pypi_version}
Release:        %{anolis_release}%{?dist}
Summary:        a foundational library for computer vision research

License:        None
URL:            https://github.com/open-mmlab/mmcv
Source0:        https://github.com/open-mmlab/mmcv/archive/refs/tags/v%{pypi_version}.tar.gz#/mmcv-%{pypi_version}.tar.gz

BuildRequires:  python3-devel
BuildRequires:  python3dist(addict)
BuildRequires:  python3dist(mmengine) >= 0.3
BuildRequires:  python3dist(numpy)
BuildRequires:  python3dist(opencv) >= 3
BuildRequires:  python3dist(packaging)
BuildRequires:  python3dist(pillow)
BuildRequires:  python3dist(pyyaml)
BuildRequires:  python3dist(regex)
BuildRequires:  python3dist(setuptools)
BuildRequires:  python3dist(yapf)
BuildRequires:  python3dist(rich)
BuildRequires:  python3dist(termcolor)
BuildRequires:  python3dist(torchvision)
BuildRequires:  python3dist(termcolor)
BuildRequires:  pytorch-devel
BuildRequires:  pytest
BuildRequires:  ninja-build

%if %{have_cuda}
BuildRequires:  cuda-nvcc-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-nvtx-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-cupti-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-nvprune-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-cudart-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-nvml-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-nvrtc-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-driver-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-profiler-api-%{vcu_maj}-%{vcu_min}
BuildRequires:  nvidia-driver-cuda-libs
BuildRequires:  libnpp-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libcurand-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libcusparse-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libcublas-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libcusolver-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libcufft-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libcurand-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libnvjpeg-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libnccl-devel
Requires:  cuda-cudart-%{vcu_maj}-%{vcu_min}
Requires:  cuda-nvrtc-%{vcu_maj}-%{vcu_min}
Requires:  cuda-nvtx-%{vcu_maj}-%{vcu_min}
%endif

%description
MMCV is a foundational library for computer vision research and it provides the following functionalities:
Image/Video processing
Image and annotation visualization
Image transformation
Various CNN architectures
High-quality implementation of common CPU and CUDA ops

%package -n     python3-%{pypi_name}
Summary:        %{summary}
%{?python_provide:%python_provide python3-%{pypi_name}}

Requires:       python3dist(addict)
Requires:       python3dist(mmengine) >= 0.3
Requires:       python3dist(numpy)
Requires:       python3dist(opencv) >= 3
Requires:       python3dist(packaging)
Requires:       python3dist(pillow)
Requires:       python3dist(pyyaml)
Requires:       python3dist(regex)
Requires:       python3dist(yapf)
Requires:       libcublas-devel-12-1
Requires:       libcurand-12-1
Requires:       python3dist(rich)
Requires:       python3dist(onnx)
Requires:       python3dist(scipy)


%description -n python3-%{pypi_name}
MMCV is a foundational library for computer vision research and it provides the following functionalities:
Image/Video processing
Image and annotation visualization
Image transformation
Various CNN architectures
High-quality implementation of common CPU and CUDA ops

%prep
%autosetup -n %{pypi_name}-%{pypi_version}
rm -rf %{pypi_name}.egg-info

%build
export TORCH_CUDA_ARCH_LIST="5.0;5.2;6.0;6.1;7.0;7.5;8.0;8.6;9.0"
export FORCE_CUDA=1
export MMCV_WITH_OPS=1
export MAX_JOBS=%{_smp_build_ncpus}
%py3_build

%install
export TORCH_CUDA_ARCH_LIST="5.0;5.2;6.0;6.1;7.0;7.5;8.0;8.6;9.0"
export FORCE_CUDA=1
export MMCV_WITH_OPS=1
export MAX_JOBS=%{_smp_build_ncpus}
%py3_install

%files -n python3-%{pypi_name}
%license LICENSE LICENSES.md
%doc README.md
%{python3_sitearch}/*

%changelog
* Thu Oct 26 2023 Zhongling He <zhonglingh@linux.alibaba.com> - 1.7.0-2
- Add build args to build mmcv-full instead of lite version.

* Thu Oct 26 2023 Zhongling He <zhonglingh@linux.alibaba.com> - 1.7.0-1
- Initial package
